//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 Yellow
#property indicator_color3 Red

//---- input parameters
extern int IchimokuPeriod=15;

//---- indicator buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
//----
int shift;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string indi_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4);
   
   SetIndexBuffer(0,Buffer1);
   SetIndexBuffer(1,Buffer2);
   SetIndexBuffer(2,Buffer3);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));

//---- name for DataWindow and indicator subwindow label   
   indi_name="Ichimoku Check("+IchimokuPeriod+")";
   IndicatorShortName(indi_name);
   SetIndexLabel(0,"bullish");
   SetIndexLabel(1,"neutral");
   SetIndexLabel(2,"bearish");
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   for(shift=Bars-1;shift>=0;shift--)
   {	
	  double SpanA=iIchimoku(NULL, IchimokuPeriod, 9, 26, 52, MODE_SENKOUSPANA, shift+1);
	  double SpanB=iIchimoku(NULL, IchimokuPeriod, 9, 26, 52, MODE_SENKOUSPANB, shift+1);
	  
	  Buffer1[shift+1]=0;
	  Buffer2[shift+1]=1;
	  Buffer3[shift+1]=0;
	  
	  if (Open[shift+1]>SpanA && Close[shift+1]>SpanA && Open[shift+1]>SpanB && Close[shift+1]>SpanB) 
	  {
	     Buffer1[shift+1]=1;
	     Buffer2[shift+1]=0;
	     Buffer3[shift+1]=0;
	  }
	  if (Open[shift+1]<SpanA && Close[shift+1]<SpanA && Open[shift+1]<SpanB && Close[shift+1]<SpanB) 
	  {
	     Buffer1[shift+1]=0;
	     Buffer2[shift+1]=0;
	     Buffer3[shift+1]=1;
	  }
	  
	}
	return(0);	
 }

